-- explode(seperator, string)
function explode(d,p)
  local t, ll
  t={}
  ll=0
  if(#p == 1) then return {p} end
    while true do
      l=string.find(p,d,ll,true) -- find the next d in the string
      if l~=nil then -- if "not not" found then..
        table.insert(t, string.sub(p,ll,l-1)) -- Save it in our array.
        ll=l+1 -- save just after where we found it for searching next time.
      else
        table.insert(t, string.sub(p,ll)) -- Save what's left in our array.
        break -- Break at end, as it should be, according to the lua manual.
      end
    end
  return t
end

function ucfirst(str)
    return (str:gsub("^%l", string.upper))
end

function DEC_HEX(IN)
    local B,K,OUT,I,D=16,"0123456789ABCDEF","",0
    while IN>0 do
        I=I+1
        IN,D=math.floor(IN/B),math.mod(IN,B)+1
        OUT=string.sub(K,D,D)..OUT
    end
    return OUT
end

function indent(val)
	ident = ""
	for i=1,val do
		ident = ident.."\t"
	end
	return ident
end

function i2f(colorInt)
	return colorInt/256
end

function dump_table(dTable, nesting)
	nesting = nesting or 0
	if dTable == nil then
		return nil
	end
	for k, v in pairs(dTable) do
		if (v) then
			if type(v) ~= "table" then
				if type(v) == "boolean" then
					if v then
						print (indent(nesting)..k..": ".."true")
					else
						print (indent(nesting)..k..": ".."false")
					end
				elseif type(v) == "string" then
					print (indent(nesting)..k..": '"..v.."'")
				else
					print (indent(nesting)..k..": "..v)
				end
			else
				print (indent(nesting)..k)
				dump_table(v, nesting+1)
			end
		else
			print (indent(nesting)..k.." = nil")
		end
	end
end